<?php
//
//	Module name      :	testtbl.php
//
//	Description      :	Test file for tbl module
//
//	Parameters       :	None
//	Notes - usage    :	None
//


//--- Include files --------------------------------------------------------------------------------



require_once("debug.php");
require_once("tbl.php");



//--- Global constants -----------------------------------------------------------------------------



define("PAGE_TIMER_NAME", "TestPage");
define("TEST_TIMER_NAME", "TestFunc");



//--- Global variables -----------------------------------------------------------------------------



$Module_prefix = "TBL";



//--- Functions code -------------------------------------------------------------------------------



function PrintFooter()
// Prints the test page footer.
{
	print "
		<!--- Start of PrintFooter ------------------------------------------------------>
		</body>
		</html>";
	$sec = DMtimerRead(PAGE_TIMER_NAME);
	print "
		<!--- End of PrintFooter -------------------------------------------------------->
		<!--- (Elapsed seconds for page construction: $sec) ------------------------->
		";
}



function PrintHeader($browser_title)
// Prints the test page header.
{
	DMtimerReset(PAGE_TIMER_NAME);
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now);						// rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0
	print "
		<!--- Start of PrintHeader ------------------------------------------------------>
		<html>
		<head>
			<title>$browser_title</title>
			<meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
		</head>
		<body>
		<!--- End of PrintHeader -------------------------------------------------------->
		";
}



function Test()
// Calls DPrint for each parameter passed; if ErrorMsg and Result are defined in the tested module,
// calls them and shows their values after the last parameter evaluation. Returns the value of the last
// parameter evaluation.
{
	global $Module_prefix;
	static $first_call = TRUE;

	$em_name = "${Module_prefix}ErrorMsg";
	$em = function_exists($em_name);
	$r_name = "${Module_prefix}Result";
	$r = function_exists($r_name);
	for ($i = 0; $i < func_num_args(); $i++)
		$result = DPrint(func_get_arg($i));
	if ($first_call)
	{
		$first_call = FALSE;
		$msec = 0;
	}
	else
		$msec = DMtimerRead(TEST_TIMER_NAME);
	DMTimerReset(TEST_TIMER_NAME);
	print "
		<table border=1 cellspacing=1 cellpadding=3 width=100%>
		<tr valign=top>
			<td width=1%>
				<center><font style='visibility:hidden'><b>DPrint</b></font></center>
			</td>
			<td><font size=-1>
				" . ($r ? "<b>${Module_prefix}Result:</b> '" . call_user_func($r_name) . "';" : "") . "
				" . ($em ? "<b>${Module_prefix}ErrorMsg:</b> '" . call_user_func($em_name) . "';" : "") . "
				<b>Elapsed secs from last call:</b> $msec</font>
			</td>
		</tr></table><br>
		";
	return $result;
}



//--- Main code ------------------------------------------------------------------------------------



	DSetDebugWindow(D_WIN_DEF_X, D_WIN_DEF_Y, D_WIN_DEF_WIDTH, D_WIN_DEF_HEIGHT, FALSE);
	PrintHeader("Test file for " . constant("${Module_prefix}_MODULE_NAME"));
	Test("Initial internal status");

	// Test code for tbl.php starts here.

	$t = array(
		"CellSpacing"		=> "0",
		"Width"				=> "100%",
		"BackColor"			=> "lightgreen",
		"BorderWidth"		=> "1",
		"BorderColor"		=> "black",
		"BorderStyle"		=> "solid",
		"TitleAlign"		=> "center",
		"TitleVAlign"		=> "middle",
		"TitlePadding"		=> "20px",
		"TitleBackColor"	=> "pink",
		"TitleColor"		=> "gray",
		"TitleFontFamily"	=> "Courier",
		"TitleFontSize"		=> "24px",
		"TitleFontWeight"	=> "normal",
		"TitleBorderWidth"	=> "5",
		"TitleBorderColor"	=> "red",
		"TitleBorderStyle"	=> "dotted",
		"Columns"			=> "2",
		"ColAlign"			=> array("left"),
		"ColWidth"			=> array("50%"),
		"ColVAlign"			=> array("top"),
		"ColPadding"		=> array("0px"),
		"ColBackColor"		=> array("white"),
		"ColColor"			=> array("red"),
		"ColFontFamily"		=> array("Arial,Helvetica,sans-serif"),
		"ColFontSize"		=> array("10px"),
		"ColFontWeight"		=> array("normal"),
		"ColBorderWidth"	=> array("1"),
		"ColBorderColor"	=> array("red"),
		"ColBorderStyle"	=> array("solid")
		);
	$c1 = array(
		"ColAlign"			=> array("right"),
		"ColWidth"			=> array("30%", "70%"),
		"ColVAlign"			=> array("bottom"),
		"ColPadding"		=> array("10px"),
		"ColBackColor"		=> array("azure"),
		"ColColor"			=> array("blue"),
		"ColFontFamily"		=> array("Times"),
		"ColFontSize"		=> array("16px"),
		"ColFontWeight"		=> array("bold"),
		"ColBorderWidth"	=> array("8"),
		"ColBorderColor"	=> array("blue"),
		"ColBorderStyle"	=> array("double")
		);
	$c2 = array(
		"ColAlign"			=> array("ca2"),
		"ColWidth"			=> array("cw2"),
		"ColVAlign"			=> array("cva2"),
		"ColPadding"		=> array("cp2"),
		"ColBackColor"		=> array("cbc2"),
		"ColColor"			=> array("cc2"),
		"ColFontFamily"		=> array("cff2"),
		"ColFontSize"		=> array("cfs2"),
		"ColFontWeight"		=> array("cfw2"),
		"ColBorderWidth"	=> array("cbw2"),
		"ColBorderColor"	=> array("cbc2"),
		"ColBorderStyle"	=> array("cbs2")
		);
	
	DPrint("<font size=+2><font color=blue><b>TBLInit</b></font></font>");
	Test($t, "\n" . htmlspecialchars(TBLInit($t)), $t);
	Test($t, "\n" . htmlspecialchars(TBLInit($t, array($c1))), $t);
	Test($t, "\n" . htmlspecialchars(TBLInit($t, array($c1, $c2))), $t);
	Test($t, "\n" . htmlspecialchars(TBLInit($t)), $t);

	DPrint("<font size=+2><font color=blue><b>TBLDone</b></font></font>");
	IReset();
	Test($t, "\n" . htmlspecialchars(TBLInit($t)), $t);
	Test($t, "\n" . htmlspecialchars(TBLDone($t)), $t);
	Test(TBLDone($t));
	IReset();
	Test($t, "\n" . htmlspecialchars(TBLInit($t) . TBLDone($t)), $t);

	DPrint("<font size=+2><font color=blue><b>TBLRow</b></font></font>");
	IReset();
	Test($t, "\n" . htmlspecialchars(TBLInit($t)), $t);
	$t["_Init"] = 1;
	Test($t, "\n" . htmlspecialchars(TBLRow($t, "a", "b")));
	unset($t["_Init"]);
	Test($t, "\n" . htmlspecialchars(TBLRow($t, "a", "b")));
	IReset();
	Test("\n" . htmlspecialchars(TBLInit($t, array($c1))), $t);
	Test("\n" . htmlspecialchars(TBLRow($t, "a", "b")));
	Test("\n" . htmlspecialchars(TBLRow($t, "c")));
	Test("\n" . htmlspecialchars(TBLRow($t, array("d"))));
	Test("\n" . htmlspecialchars(TBLDone($t)));
	print
		TBLInit($t, array($c1)) .
		TBLRow($t, "A<br>A", "B") .
		TBLRow($t, "C<br>C", "C") .
		TBLRow($t, array("D<br>D", "D")) .
		TBLRow($t, "A<br>A", "B") .
		TBLRow($t, "C<br>C", "C") .
		TBLRow($t, array("D<br>D", "D")) .
		TBLDone($t);

	DPrint("<font size=+2><font color=blue><b>TBLTitle</b></font></font>");
	IReset();
	Test("\n" . htmlspecialchars(TBLInit($t, array($c1))));
	Test("\n" . htmlspecialchars(TBLTitle($t, "Titolo")));
	Test("\n" . htmlspecialchars(TBLTitle($t, "&nbsp;")));
	Test("\n" . htmlspecialchars(TBLTitle($t)));
	Test("\n" . htmlspecialchars(TBLDone($t)));
	print
		TBLInit($t, array($c1)) .
		TBLTitle($t, "Titolo") .
		TBLTitle($t, "&nbsp;") .
		TBLTitle($t) .
		TBLDone($t);

	DPrint("<font size=+2><font color=blue><b>TBLEmpty</b></font></font>");
	IReset();
	Test("\n" . htmlspecialchars(TBLInit($t, array($c1))));
	Test("\n" . htmlspecialchars(TBLEmpty($t, "Titolo")));
	Test("\n" . htmlspecialchars(TBLEmpty($t, "&nbsp;")));
	Test("\n" . htmlspecialchars(TBLEmpty($t)));
	Test("\n" . htmlspecialchars(TBLDone($t)));
	print
		TBLInit($t, array($c1)) .
		TBLEmpty($t, "Titolo") .
		TBLEmpty($t) .
		TBLEmpty($t, "&nbsp;") .
		TBLDone($t);

	DPrint("<font size=+2><font color=blue><b>TBLNextSet</b></font></font>");
	IReset();
	Test("\n" . htmlspecialchars(TBLInit($t, array($c1))));
	Test("\n" . htmlspecialchars(TBLRow($t, "a", "b")));
	Test("\n" . htmlspecialchars(TBLRow($t, "c", "d")));
	Test("\n" . htmlspecialchars(TBLRow($t, "e", "f")));
	Test("\n" . htmlspecialchars(TBLRow($t, "g", "h")));
	Test(TBLNextSet($t, 1));
	Test("\n" . htmlspecialchars(TBLRow($t, "i", "j")));
	Test(TBLNextSet($t, 1));
	Test("\n" . htmlspecialchars(TBLRow($t, "k", "l")));
	Test("\n" . htmlspecialchars(TBLRow($t, "m", "n")));
	Test("\n" . htmlspecialchars(TBLDone($t)));
	print
		TBLInit($t, array($c1)) .
		TBLRow($t, "a", "b") .
		TBLRow($t, "c", "d") .
		TBLRow($t, "e", "f") .
		TBLRow($t, "g", "h") .
		TBLNextSet($t, 1) .
		TBLRow($t, "i", "j") .
		TBLNextSet($t, 1) .
		TBLRow($t, "k", "l") .
		TBLRow($t, "m", "n") .
		TBLDone($t);

	// Test code for tbl.php ends here.

	Test("Final internal status");
	PrintFooter();	
?>
